<?php 
// USERS LIST PAGE
global $pc_users, $pc_wp_user;
$nonce = wp_create_nonce('pc_ulist');


// base page URL
$base_page_url = admin_url() . 'admin.php?page=pc_user_manage';

// first/last name flag 
$fist_last_name = get_option('pg_use_first_last_name');

// user categories
$user_categories = pc_static::user_cats();

// WP user sync check
$wp_user_sync = $pc_users->wp_user_sync;

// minimum level to manage users
$cuc = $GLOBALS['pc_cuc_edit'];



// bulk action dropdown
$bulk_act_dd = '';

if($cuc) {
    $bulk_act_dd = '
    <select name="pc_ulist_action" class="pc_ulist_action" autocomplete="off">
        <option value="">'. esc_html__('Bulk Actions', PC_ML) .'</option>';

        if(isset($_GET['status']) && ($_GET['status'] == 2 || $_GET['status'] == 3)) {
            $bulk_act_dd .= '
            <option value="enable">'. esc_html__('Enable', PC_ML) .' '. esc_html__('Users', PC_ML) .'</option>';
        }
        else {
            $bulk_act_dd .= '
            <option value="disable">'. esc_html__('Disable', PC_ML) .' '. esc_html__('Users', PC_ML) .'</option>';
        }

        $bulk_act_dd .= '
        <option value="delete">'. esc_html__('Delete', PC_ML) .' '. esc_html__('Users', PC_ML) .'</option>';

        if(!isset($_GET['status']) || $_GET['status'] != 3) { 
            $bulk_act_dd .= '
            <option value="cat_change">'. esc_html__('Change categories', PC_ML) .'</option>';
        }

    $bulk_act_dd .= '
    </select>
    <input type="button" value="'. esc_html__('Apply', PC_ML) .'" class="button-secondary pc_bulk_action_btn" name="ucat_action">';
}
    

// current page
$curr_pag = (isset($_GET['pagenum']) && (int)$_GET['pagenum']) ? (int)$_GET['pagenum'] : 1; 


// per page - controlled by screen options
$per_page = (int)get_user_meta(get_current_user_id(), 'pc_ulist_per_page', true);
if(empty($per_page) || $per_page < 1) {
    $per_page = 20;
}



//////////////////////////////////////////////////////////////////////////////




// current viewing status
if(!isset($_GET['status']) || isset($_GET['status']) && $_GET['status'] == 1) {
    $status = '1';
}
elseif($_GET['status'] == '2') {
    $status = '2';
}
else {
    $status = '3';
}




//////////////////////////////////////////////////////////////////////////////




// QUERY ARGS

$table_cols = pc_static::get_ulist_columns();
$fixed_cols = array(
    'id' => array(
        'name' 		=> 'ID',
        'sortable' 	=> true,
        'width'		=> '45px',
        'is_date'   => false,
    ),
    'username' => array(
        'name' 		=> __('Username', PC_ML),
        'sortable' 	=> true,
        'is_date'   => false,
    ),
);
$table_cols = array_merge($fixed_cols, $table_cols); // prepend fixed keys



$concat_cond = (pc_static::get_param_exists('basic_search') || pc_static::get_param_exists('pc_cat') || pc_static::get_param_exists('advanced_search')) ? 'AND' : '';
$basic_cat_search_cond = ''; // empty var for simple cat filter for paginators

$args = array(
	'to_get'	=> array_merge(array_keys($table_cols), array('page_id', 'disable_pvt_page', 'wp_user_id')),
	'limit' 	=> $per_page,
	'offset' 	=> ($curr_pag > 1) ? $per_page * ($curr_pag - 1) : 0,
	'custom_search'		=> $concat_cond.' status = '.(int)$status,
	'search_operator' 	=> 'AND',
	'search'	=> array()
);


// basic search
if(pc_static::get_param_exists('basic_search') || pc_static::get_param_exists('pc_cat')) {
	$args['search_operator'] = 'OR';
	
	if(pc_static::get_param_exists('basic_search')) {
		$search_in = array('username', 'name', 'surname', 'email');
		foreach($search_in as $key) {
			$args['search'][] = array('key'=>$key, 'val'=>'%'. $_GET['basic_search'] .'%', 'operator' => 'LIKE');	
		}
	}
	
	if(pc_static::get_param_exists('pc_cat')) {
		$init_cat_cond = (pc_static::get_param_exists('basic_search')) ? ' AND ' : '';
		$basic_cat_search_cond = ' '. $init_cat_cond . $pc_users->categories_query($_GET['pc_cat']) .' '; 
		$args['custom_search'] = $basic_cat_search_cond .' '. $args['custom_search'];
	}	
}


// advanced search
elseif(pc_static::get_param_exists('advanced_search')) {
	$sanitized_str = str_replace(array('%5B', '%5D'), array('[', ']'), $_GET['advanced_search']);
	parse_str($sanitized_str, $as_params);
	
	$args['search_operator'] = $as_params["pc_as_global_cond"];

	// search structure
	for($a=0; $a < count($as_params['pc_as_fields']); $a++) {	
		
		// operator translation
		switch($as_params['pc_as_cond'][$a]) {
			case 'different': $op = '!='; break;
			case 'bigger'	: $op = '>'; break;
			case 'smaller'	: $op = '<'; break;
			case 'like'		: $op = 'LIKE'; break;
			case '='        : 
			default         : $op = '='; break;	
		}
		
		$as_val = ($op == 'LIKE') ? '%'. $as_params['pc_as_val'][$a] .'%' : $as_params['pc_as_val'][$a];
 	
		$args['search'][] = array(
			'key' => $as_params['pc_as_fields'][$a], 
			'val' => stripslashes($as_val), 
			'operator' => $op
		);
	}
}


// sorting
if(isset($_GET['orderby']) && !empty($_GET['orderby'])) {
	$args['orderby'] = $_GET['orderby'];	
}

if(isset($_GET['order']) && in_array(strtolower($_GET['order']), array('asc', 'desc')) ) {
	$args['order'] = strtolower($_GET['order']);	
} else {
	$args['order'] = 'desc';	
}


//////////////////////////////////////////

$rows_count_args = $args;
$rows_count_args['count'] = true;
$rows_count_args['limit'] = -1;
if(isset($rows_count_args['offset'])) {
    unset($rows_count_args['offset']);
}


// total rows for active users
$rows_count_args['custom_search'] = $basic_cat_search_cond . $concat_cond.' status = 1';
$total_act_rows = $pc_users->get_users($rows_count_args);

// total rows for disabled users
$rows_count_args['custom_search'] = $basic_cat_search_cond . $concat_cond.' status = 2';
$total_dis_rows = $pc_users->get_users($rows_count_args);

// total rows for pending users
$rows_count_args['custom_search'] = $basic_cat_search_cond . $concat_cond.' status = 3';
$total_pen_rows = $pc_users->get_users($rows_count_args);


if 		($status == 1) 	{$total_rows = $total_act_rows;}
elseif 	($status == 2) 	{$total_rows = $total_dis_rows;}
else 					{$total_rows = $total_pen_rows;}


// re-check for current page (in case deleted user made total decrease)
$tot_pages = ceil((int)$total_rows / $per_page);
if($curr_pag > $tot_pages) {
    $args['offset'] = ($tot_pages > 1) ? $per_page * ($tot_pages - 1) : 0;
}

$user_query = $pc_users->get_users($args);
$pagbtn_code = pc_static::users_list_pag_block($curr_pag, $per_page, $total_rows);
?>

<div class="pc_ulist_big_spinner pc_displaynone">
    <div class="pc_spinner pc_spinner_big"></div>
</div>

<div class="wrap pc_form">  
	<?php
	// page title
	echo '
	<h2 class="pc_page_title">' . 
		__( 'PrivateContent Users', PC_ML ) . 
		' <a class="add-new-h2 pc_add_user_btn" href="'. admin_url() .'admin.php?page=pc_user_dashboard">
            <i class="fas fa-plus-circle"></i>
            '. __( 'Add New', PC_ML) .'
        </a>
	</h2>'; 

	// MESSAGE IN RELATION TO THE ACTION PERFORMED
    if(isset($act_message)) { 
    	echo '<div class="updated"><p><strong>'. $act_message .'</strong></p></div>';	
	}
	
	
	// keep eventual search parameters changing status
	$clean_url = pc_static::man_url_attr('remove', 'pagenum');

	// STATUS LINKS ?>
    <h2 class="nav-tab-wrapper pc_ulist_statuses">
        <?php $url_arr['status'] = 1; ?>
        <a class="nav-tab <?php if($status == $url_arr['status']) echo 'nav-tab-active'; ?> pc_ulist_active_tab" href="<?php echo pc_static::man_url_attr('edit', 'status', $url_arr['status'], $clean_url) ?>">
            <?php _e('Actives', PC_ML) ?> <span><?php echo $total_act_rows ?></span>
        </a>
        
        <?php $url_arr['status'] = 2; ?>
        <a class="nav-tab <?php if($status == $url_arr['status']) echo 'nav-tab-active'; ?> pc_ulist_disabled_tab" href="<?php echo pc_static::man_url_attr('edit', 'status', $url_arr['status'], $clean_url) ?>">
            <?php _e('Disabled', PC_ML) ?> <span><?php echo $total_dis_rows ?></span>
        </a>
        
        <?php $url_arr['status'] = 3; ?>
        <a class="nav-tab <?php if($status == $url_arr['status']) echo 'nav-tab-active'; ?> pc_ulist_pending_tab" href="<?php echo pc_static::man_url_attr('edit', 'status', $url_arr['status'], $clean_url) ?>">
            <?php _e('Pending', PC_ML) ?> <span><?php echo $total_pen_rows ?></span>
        </a>
    </h2>
    
    
    
    <?php
    // TABLE TH-s
    $table_th = '
    <tr>';   
           
        if($cuc) {
            $table_th .= '
            <th id="cb" class="manage-column column-cb check-column" scope="col">
                <input type="checkbox" autocomplete="off" />
            </th>
            <th>&nbsp;</th>'; // buttons
        } 
           
        $table_th .= '
        <th>
            <a class="pc_filter_th" rel="id">ID</a>
        </th>
        <th class="pc_ulist_badges_th">&nbsp;</th>'; // user badges
 
        foreach($table_cols as $key => $data) {
            if($key == 'id') {
                continue;
            }
            
            $width = (isset($data['width'])) ? 'style="width: '.$data['width'].';"' : '';
            $sortable = (isset($data['sortable']) && $data['sortable']) ? '<a class="pc_filter_th" rel="'. $key .'">'. $data['name'] .'</a>' : $data['name'];
            
            $table_th .= '<th '.$width.' class="pc_ulist_'.$key.'_th">'. $sortable .'</th>';	
        }
           
    $table_th .= '       
    </tr>';
    
    
    // TABLE START ?>
    <form method="get" id="pc_user_list_form" action="<?php echo $base_page_url ?>">
        <?php
        // advanced search summary
        if(pc_static::get_param_exists('advanced_search') ) {
            echo '
            <div class="pc_ulist_as_summary">
                <h4>Search parameters:</h4>
                <ul>';

                    for($a=0; $a < count($as_params['pc_as_fields']); $a++) {	
                        $operator   = $as_params['pc_as_cond'][$a];
                        $data       = $table_cols[ $as_params['pc_as_fields'][$a] ]; 

                        if(isset($data['is_date']) && $data['is_date']) {
                            switch($operator) {
                                case 'like'     : $cond_txt = __('during', PC_ML); break;     
                                case 'bigger'   : $cond_txt = __('is sooner than', PC_ML); break;     
                                case 'smaller'  : $cond_txt = __('is older than', PC_ML); break;     
                            }   
                        }
                        else {
                            switch($operator) {
                                case 'equal'        : $cond_txt = __('is equal to', PC_ML); break;     
                                case 'different'    : $cond_txt = __('is different from', PC_ML); break;     
                                case 'bigger'       : $cond_txt = __('is greater than', PC_ML); break;     
                                case 'smaller'      : $cond_txt = __('is lower than', PC_ML); break;     
                                case 'like'         : $cond_txt = __('contains', PC_ML); break;         
                            }    
                        }

                        echo '<li>"'. $data['name'] .'" '. $cond_txt .' '. $as_params['pc_as_val'][$a] .'</li>';
                    }

                echo '
                </ul>
            </div>';    
        }
        ?>
        <div class="tablenav pc_users_list_navbar">
            <?php echo $pagbtn_code; ?>

            <input type="hidden" name="page" value="pc_user_manage" />
            <input type="hidden" name="pagenum" value="1" /> <!-- set to one to reset pagination while searching -->
            <input type="hidden" name="status" value="<?php 
				if($status == 1) 	{echo 1;}
				elseif($status == 2){echo 2;}
				else 				{echo 3;}
				?>" 
            />
            
            
            <div class="pc_ulist_search_block">
                <?php if(!pc_static::get_param_exists('advanced_search') ) : ?>
                    <input type="text" name="basic_search" value="<?php echo (isset($_GET['basic_search'])) ? esc_attr($_GET['basic_search']) : ''; ?>" size="25" class="pc_ulist_search_field" placeholder="🔍 <?php esc_attr_e('username, name, surname, e-mail', PC_ML) ?>" autocomplete="off" />

                    <select name="pc_cat" id="pc_ulist_filter" autocomplete="off">
                        <option value=""><?php esc_html_e('All Categories', PC_ML) ?></option>
                        <?php
                        foreach ($user_categories as $cat_id => $cat_name) {
                            $ucat_sel = (isset($_GET['pc_cat']) && (int)$_GET['pc_cat'] == $cat_id) ? 'selected="selected"' : '';
                            echo '<option value="'. $cat_id .'" '.$ucat_sel.'>'. esc_html($cat_name) .'</selected>';	
                        }
                        ?>
                    </select>
                <?php else : ?>    
                    <input type="button" value="<?php esc_attr_e('Clean advanced search', PC_ML); ?>" class="button-secondary pc_clean_advanced_search" />
                <?php endif; ?>

                <?php if(!isset($_GET['advanced_search']) || empty($_GET['advanced_search'])) : ?>
                    <input type="submit" value="<?php esc_attr_e('Search', PC_ML); ?>" class="button-secondary" name="ucat_filter">
                <?php endif; ?>

                <input type="button" value="<?php esc_attr_e('Advanced search', PC_ML); ?>" class="<?php echo (isset($as_params)) ? 'button-primary' : 'button-secondary'; ?> pc_advanced_search_btn" data-mfp-src="#pc_adv_search" />
            </div> 
            
            <?php 
            if($cuc && !empty($user_query)) { 
                echo $bulk_act_dd;
            }
            ?> 
    	</div>
        
        <?php 
		/************************************************************
		************************************************************/
        
        // print table only if users are found
        if(!empty($user_query)) :
		?>
            <table class="widefat pc_table pc_users_list">
                <thead>
                    <?php echo $table_th ?>
                </thead>
                <tfoot>
                    <?php echo $table_th ?>
                </tfoot>

                <tbody>
                  <?php 
                  foreach($user_query as $u) : 
                  ?>
                    <tr class="content_row" data-uid="<?php echo (int)$u['id'] ?>">

                        <?php if($cuc) : ?>  
                            <td class="pc_ulist_bulk_check_wrap">
                                <input type="checkbox" name="pc_users[]" value="<?php echo (int)$u['id'] ?>" autocomplete="off" />
                            </td>
                            <td class="pc_ulist_icons">
                                <i class="fas fa-times-circle del_pc_user pc_delete_user_btn" title="<?php esc_attr_e('Delete user', PC_ML); ?>"></i>

                            <?php // ENABLE / ACTIVATE / DISABLE USER
                            if(isset($_GET['status']) && $_GET['status'] == 2) : // enable ?>
                                <i class="fas fa-check-circle pc_enable_user_btn" title="<?php esc_attr_e('Enable user', PC_ML); ?>"></i>

                            <?php 
                            elseif(isset($_GET['status']) && $_GET['status'] == 3) : // activate ?>
                                <i class="fas fa-check-circle pc_activate_user_btn" title="<?php esc_attr_e('Activate user', PC_ML); ?>"></i>

                            <?php else: // disable ?>
                                <i class="fas fa-minus-circle pc_disable_user_btn" title="<?php esc_attr_e('Disable user', PC_ML); ?>"></i>

                            <?php endif; ?>

                            <?php // EDIT USER PAGE
                            if(get_option('pg_target_page') && empty($u['disable_pvt_page']) && (!isset($_GET['status']) || $_GET['status'] != 3) ) : ?>
                                <a href="<?php echo admin_url(); ?>post.php?post=<?php echo $u['page_id'] ?>&action=edit" class="pc_edit_user_page_btn">
                                    <i class="fas fa-edit" title="<?php esc_attr_e('Edit user reserved area', PC_ML); ?>"></i>
                                </a>
                            <?php endif; ?>  
                            </div>    
                        </td>
                        <?php endif; // end cuc (curr user can) ?>

                        <td>
                            <?php echo $u['id'] ?>
                        </td>
                        <td class="pc_ulist_badges">
                            <?php 
                            $badges = '';

                            if($wp_user_sync && !empty($u['wp_user_id'])) {
                                 $badges = '<img src="'.PC_URL.'/img/wp_synced.png" title="'. esc_attr__('Synced with WP user', PC_ML).' - ID '. $u['wp_user_id'].'" />';
                            }

                            // PC-FILTER - users list badges - show an image badge relatd to a user
                            echo apply_filters('pc_users_list_badges', $badges, $u['id']);
                            ?>
                        </td>
                        <td>
                            <a href="<?php echo admin_url(); ?>admin.php?page=pc_user_dashboard&user=<?php echo (int)$u['id'] ?>" class="pc_edit_user_link" title="<?php esc_attr_e('edit user', PC_ML) ?>">
                                <strong><?php echo $u['username'] ?></strong>
                            </a>
                        </td>

                        <?php 
                        foreach($table_cols as $key => $data) {
                            if(in_array($key, array('id', 'username'))) {
                                continue;
                            }
                            $managed = ($key == 'categories') ? pc_static::ulist_user_cats_td($u[$key]) : $pc_users->data_to_human($key, $u[$key]);

                            // PC-FILTER - allow advanced management over specific user data shown in users list - passes managed val, user ID, column ID, raw DB val
                            $val = apply_filters('pc_users_list_table_fields_val', $managed, $u['id'], $key, $u[$key]); 

                            echo '<td class="pc_ulist_'. esc_attr($key) .'_td">'. $val .'</td>'; 	 
                        }
                        ?>
                    <?php endforeach; ?>
                </tbody>
            </table>
        
        <?php else : // no users are found  ?>
            <div class="pc_ulist_no_users">
                <i class="fas fa-users-slash"></i>
                <span>.. <?php _e('no users found', PC_ML) ?> ..</span>
            </div>

        <?php endif; // print table only if users are found ?>
	</form>
    
    
    <div class="tablenav">
        <?php 
        if($cuc && !empty($user_query)) { 
            echo $bulk_act_dd;
        }
        
        echo $pagbtn_code; ?> 
    </div>
</div>






<?php // ADVANCED SEARCH FORM ?>
<div class="pc_displaynone">
    <form id="pc_adv_search">
        <button class="mfp-close" type="button" title="<?php esc_attr_e('Close (Esc)', PC_ML) ?>">×</button>
        <table class="widefat pc_table">
          <tr>
            <td colspan="2" data-for="pc_as_global_cond"><?php _e('Conditions matching', PC_ML) ?></td>
            <td>
                <select name="pc_as_global_cond" autocomplete="off">
                    <option value="OR"><?php esc_html_e('at least one must match', PC_ML) ?></option>
                    <option value="AND" <?php if(isset($as_params) && $as_params["pc_as_global_cond"] == 'AND') {echo 'selected="selected"';} ?>><?php esc_html_e('every condition must match', PC_ML) ?></option>
                </select>
            </td>
          </tr>
          <tr>
            <td colspan="2">
                <select name="pc_as_fields" class="pc_as_fields" autocomplete="off">
                    <?php 
                    foreach($table_cols as $key => $val) {
                        if(!isset($val['sortable']) || !$val['sortable']) { // only sortable/searchable fields
                            continue;
                        }
                        if(in_array($key, array('id'/*, 'insert_date', 'last_access'*/))) { // discard date fields for now
                            continue;
                        }

                        $is_date_attr = (isset($val['is_date']) && $val['is_date']) ? 1 : 0;
                        echo '<option value="'. $key .'" data-is-date="'. $is_date_attr .'">'. esc_html($val['name']) .'</option>';
                    }		
                    ?>
                </select>
            </td>
            <td><input type="button" name="pc_as_add_cond" value="<?php esc_attr_e('Add condition', PC_ML) ?>" class="button-secondary pc_as_add_cond" /></td>
          </tr>
        </table>

        <table id="pc_as_conds" class="widefat pc_table <?php if(!isset($as_params)) {echo 'pc_displaynone';} ?>">
        <?php 
        if(isset($as_params)) {
            for($a=0; $a < count($as_params['pc_as_fields']); $a++) {	
                
                $operator   = $as_params['pc_as_cond'][$a];
                $data       = $table_cols[ $as_params['pc_as_fields'][$a] ]; 
                $f_name     = $data['name'];
                $f_class    = str_replace(' ', '_', $as_params['pc_as_fields'][$a]);
                $f_type     = (isset($data['is_date']) && $data['is_date']) ? 'date' : 'text';
                
                if($f_type == 'date') {
                    $opts = '
                    <option value="like" '. selected('like', $operator, false) .'>'. esc_attr__('during', PC_ML) .'</option>
                    <option value="bigger" '. selected('bigger', $operator, false) .'>'. esc_attr__('is sooner than', PC_ML) .'</option>	
                    <option value="smaller" '. selected('smaller', $operator, false) .'>'. esc_attr__('is older than', PC_ML) .'</option>';
                }
                else {
                    $opts = '
                    <option value="equal" '. selected('equal', $operator, false) .'>'. esc_attr__('is equal to', PC_ML) .'</option>
                    <option value="different" '. selected('different', $operator, false) .'>'. esc_attr__('is different from', PC_ML) .'</option>	
                    <option value="bigger" '. selected('bigger', $operator, false) .'>'. esc_attr__('is greater than', PC_ML) .'</option>	
                    <option value="smaller" '. selected('smaller', $operator, false) .'>'. esc_attr__('is lower than', PC_ML) .'</option>
                    <option value="like" '. selected('like', $operator, false) .'>'. esc_attr__('contains', PC_ML) .'</option>';
                }
                
                ?>
                <tr class="<?php echo $f_class ?>"><td>
                    <span class="pc_as_remove_cond dashicons dashicons-no-alt" title="<?php esc_attr_e('remove condition', PC_ML) ?>"></span>
                    <h4><?php echo $f_name ?></h4>
                    <div class="pc_as_conds_fwrap">
                        <input type="hidden" name="pc_as_fields[]" value="<?php echo esc_attr($as_params['pc_as_fields'][$a]) ?>" autocomplete="off" />
                        
                        <select name="pc_as_cond[]">
                            <?php echo $opts ?>
                        </select>
                        
                        <input type="<?php echo $f_type ?>" name="pc_as_val[]" value="<?php echo esc_attr($as_params['pc_as_val'][$a]) ?>" autocomplete="off" />
                    </div>
                </td></tr>
                <?php
            }
        }
        ?>
        </table>
        <input type="button" name="pc_as_submit" value="<?php esc_attr_e('Search', PC_ML) ?>" id="pc_as_submit" class="button-primary <?php if(!isset($as_params)) {echo 'pc_displaynone';} ?>" />
    </form>
</div>







<?php // BULK CATEGORIES CHANGE FORM ?>
<div class="pc_displaynone">
    <form id="pc_bulk_cat_change">
        <button class="mfp-close" type="button" title="<?php esc_attr('Close (Esc)', PC_ML) ?>">×</button>

        <select name="pc_bcc_cats" class="pc_lc_select pc_bcc_cats" data-placeholder="<?php esc_attr_e('Select categories', PC_ML) ?> .." autocomplete="off" multiple="multiple">
            <?php 
            foreach($user_categories as $cat_id => $cat_name) {
                echo '<option value="'. $cat_id .'">'. esc_html($cat_name) .'</option>';	
            }
            ?>
        </select>
        <br/>
        
        <input type="button" value="<?php esc_attr_e('Set', PC_ML) ?>" class="button-primary pc_bcc_submit" />
        <span class="pc_bcc_response"></span>
    </form>
</div>





<script type="text/javascript">
(function($) { 
    "use strict";    

	const nonce = "<?php echo wp_create_nonce('lcwp_ajax') ?>",
          user_sorted_cols = JSON.parse('<?php echo json_encode((array)get_user_meta(get_current_user_id(), 'pc_ulist_columns', true)) ?>');
    
    
    // pagenum change
    let pagenum_keyup_tout = false;
    $(document).on('keyup', '.pc_ulist_pagenum_input', function(e) {
        if(e.keyCode === 13) { 
            e.preventDefault();    
        }
        
        const $this     = $(this),
              max_val   = parseInt( $this.data('tot-pag'), 10);
        
        if(pagenum_keyup_tout) {
            clearTimeout(pagenum_keyup_tout);    
        }
        pagenum_keyup_tout = setTimeout(function() {
            let url = "<?php echo pc_static::man_url_attr('add', 'pagenum', 'JS-VAL'); ?>";
            
            let new_pag = parseInt($this.val(), 10);
            if(new_pag < 1) {
                new_pag = 1;    
            }
            else if(new_pag > max_val) {
                new_pag = max_val;    
            }
            
            window.location.href = url.replace('JS-VAL', new_pag);
        }, 500);
    });
    
    
    
    // page settings - add specific class to manage columns toggles easier
    $(document).ready(function() {
        $('.hide-column-tog').each(function() {
            $(this).parent().addClass('pc_ulist_col_toggle').attr('data-name', $(this).val()).prepend('<i></i>');    
            $(this).attr('autocomplete', 'off');
        });
        $(".pc_ulist_col_toggle").wrapAll('<div class="pc_ulist_col_toggle_wrap"></div>');
        
        
        // sort following user choices
        if(typeof(user_sorted_cols) == 'object') {
            const reversed = user_sorted_cols.reverse();
            
            $.each(reversed, function(key, val) {
                const $col = $('.pc_ulist_col_toggle[data-name="'+ val.id +'"]').detach();
                $('.pc_ulist_col_toggle_wrap').prepend($col);
                
                if($('.hide-column-tog[name="'+ val.id +'-hide"]').length) {
                    $('.hide-column-tog[name="'+ val.id +'-hide"]')[0].checked = (parseInt(val.checked, 10)) ? true : false;
                }
            });
        }
        
        
        // custom restrictions - sortable
        $(".pc_ulist_col_toggle_wrap").sortable({ 
            handle: 'i',
            update: function() {
                save_ulist_cols();        
            },
        });
        $(".pc_ulist_col_toggle").disableSelection();
    });
    
    
    // save shown columns - on toggle
    $(document).on('click', '.pc_ulist_col_toggle', function() {
        save_ulist_cols();    
    });
    
    
    // save shown columns and their order
    let save_ulist_cols_ajax = false;
    
    const save_ulist_cols = function() {
        const checkboxes = $('#screen-options-wrap .metabox-prefs input[type="checkbox"]');        
        let data = [];    
        
        $('.pc_ulist_col_toggle').each(function() {
            data.push({
                id      : $(this).find('input').val(),
                checked : ($(this).find('input').is(':checked')) ? 1 : 0,
            });   
        });
        
        if(save_ulist_cols_ajax) {
            save_ulist_cols_ajax.abort();    
        }
        
        let ajax_data = {
            action  : 'pc_ulist_update_user_cols',
            cols    : data,
            nonce   : nonce
        };
        save_ulist_cols_ajax = $.post(ajaxurl, ajax_data, function(response) {
            if($.trim(response) != 'success') {
                lc_wp_popup_message('error', "<?php esc_html_e('Error updating shown columns', PC_ML) ?>");
            }
        })
        .fail(function(e) {
            if(e.status) {
                console.error(e);
                lc_wp_popup_message('error', "<?php esc_html_e('Error updating shown columns', PC_ML) ?>");
            }
        });
    };
    
    
    
    // select/deselect all
	$('#cb input').on('click', function() {
		($(this).is(':checked')) ? $('.pc_ulist_bulk_check_wrap input').prop('checked', 'checked') : $('.pc_ulist_bulk_check_wrap input').removeAttr('checked');
	});
    
    
    
    // retrieve selected user IDs
    const get_selected_users = function() {
        let users = [];
        
        $('table.pc_users_list tbody tr').each(function() {
            
            if($(this).find('.pc_ulist_bulk_check_wrap input').is(':checked')) {
                users.push( parseInt($(this).data('uid'), 10));  
            }
        });  
        
        return users;
    };
    
    
    
    /////////////////////////////////////////////////////////////////////////
    
    
    
    <?php if($cuc) : ?>
    
    // bulk action - btn click handler
	$(document).on('click', '.pc_bulk_action_btn', function() {
		const action    = $('.pc_ulist_action').val(),
              sel_users = get_selected_users();
		
        if(!action || !sel_users.length) {
            return false;    
        }
        
        // change categories
		if(action == 'cat_change') {
			$.magnificPopup.open({
				  items: {
					  src: '#pc_bulk_cat_change',
					  type: 'inline'
				  },
				  preloader: false,
                  mainClass: 'pc_bulk_cat_change_lb',
				  callbacks: {
					beforeOpen: function() {
					  if($(window).width() < 800) {
						this.st.focus = false;
					  }
					},
					open: function() {
                        new lc_select('.pc_bulk_cat_change_lb .pc_lc_select', {
                            wrap_width : '100%',
                            addit_classes : ['lcslt-lcwp', 'pc_scw_field_dd'],
                        });
					}
				  }
			});
		}
        
        else {
            manage_users(action, sel_users);
        }
	});
    
    
    
	// bulk cat change - perform
	$(document).on('click', '.pc_bcc_submit', function() {
		var val = $('.lcslt-f-pc_bcc_cats .pc_bcc_cats').val();
		
        if(!val || !confirm("<?php esc_attr_e('Existing user categories will be overwritten. Continue?', PC_ML) ?>")) {
            return false;
        }

        $('.pc_bcc_response').html('<i class="pc_spinner"></i>');

        const data = {
            action  : 'pc_bulk_cat_change',
            users   : get_selected_users(),
            cats    : val,
            nonce   : nonce
        };
        $.post(ajaxurl, data, function(response) {
            if($.trim(response) != 'success'){
                $('.pc_bcc_response').html(response);
                return false;	
            }

            $('.pc_bcc_response').html("<?php esc_attr_e('Done', PC_ML) ?>!");
            location.reload(); 
        })
        .fail(function(e) {
            if(e.status) {
                console.error(e);
                lc_wp_popup_message('error', "<?php esc_html_e('Error changing users categories', PC_ML) ?>");
            }
        });
	});
    
    
    
    // single user management
    $(document).on('click', '.pc_delete_user_btn', function() {
        const uid = $(this).parents('tr').data('uid');
        manage_users('delete', uid);
    });
    $(document).on('click', '.pc_disable_user_btn', function() {
        const uid = $(this).parents('tr').data('uid');
        manage_users('disable', uid);
    });
    $(document).on('click', '.pc_enable_user_btn, .pc_activate_user_btn', function() {
        const uid = $(this).parents('tr').data('uid');
        manage_users('enable', uid);
    }); 
    
    
    
    // manage users (disable | enable | delete) - handles single user ID or IDs array
    const manage_users = function(cmd, users) {
        if(!users) {
            return false;    
        }
        if(typeof(users) != 'object') {
            users = [users];    
        }
              
        if(cmd == 'delete') {
            if(users.length > 1) {
                if(!confirm("<?php esc_attr_e('Do you really want to delete these users?', PC_ML) ?>")) {
                    return false;
                }
            }
            else {
                if(!confirm("<?php esc_attr_e('Do you really want to delete the user?', PC_ML) ?>")) {
                    return false;
                }        
            }
        }
        
        
        $('.pc_ulist_big_spinner').fadeIn();
        
        const data = {
            action  : 'pc_ulist_manage_users',
            users   : users,
            pc_cmd  : cmd,
            nonce   : nonce
        };
        $.post(ajaxurl, data, function(response) {
            try {
                const resp = JSON.parse(response);

                if(resp.status != 'success') {
                    lc_wp_popup_message('error', resp.message);        
                }

                // remove table rows
                $.each(resp.processed_users, function(i, uid) {
                    $('table.pc_users_list tbody tr[data-uid="'+ uid +'"]').remove();    
                });

                // change tab counter
                $('.pc_ulist_statuses .nav-tab-active span').text( parseInt($('.pc_ulist_statuses .nav-tab-active span').text(), 10) - resp.processed_users.length);

                if(cmd == 'enable') {
                    $('.pc_ulist_active_tab span').text( parseInt($('.pc_ulist_active_tab span').text(), 10) + resp.processed_users.length);        
                }
                else if(cmd == 'disable') {
                    $('.pc_ulist_disabled_tab span').text( parseInt($('.pc_ulist_disabled_tab span').text(), 10) + resp.processed_users.length);        
                }
            }
            catch(e) {
                console.error(e);
                lc_wp_popup_message('error', "<?php esc_attr_e('Error performing the action', PC_ML) ?>");    
                
                $('.pc_ulist_big_spinner').fadeOut(); 
            }
        })
        .fail(function(e) {
            if(e.status) {
                console.error(e);
                lc_wp_popup_message('error', "<?php esc_html_e('Error performing the action', PC_ML) ?>");
            }
        })
        .always(function() {
            $('.pc_ulist_big_spinner').fadeOut();        
        });
    };
	<?php endif; // cuc ?>
	
    
    
    /////////////////////////////////////////////////////////////////////////
    
    
    
	/* advanced search - submit form */
	$(document).on('click', '#pc_as_submit', function() {
		// check value fields - must have something in
		var val_f_check = true;
		$('#pc_adv_search div input[type=text]').each(function() {
			if($.trim( $(this).val()) == '') {val_f_check = false;}
        });
		if(!val_f_check) {
			alert("<?php esc_attr_e('insert a value for each condition', PC_ML) ?>");
			return false;
		}
		
		// clean previous search parameters
		var url_arr = window.location.href.split('&');
		var new_arr = [];
		
		$.each(url_arr, function(i, v) {
			if(typeof(v) != 'undefined') {
				if(v.indexOf('advanced_search=') === -1 && v.indexOf('basic_search=') === -1 && v.indexOf('pc_cat=') === -1) {
					new_arr.push(v);
				}
			}
		});
		
		window.location.href = new_arr.join('&') + '&advanced_search=' + encodeURIComponent($('#pc_adv_search').serialize()); 
	});
	
	
	/* advanced search - remove condition */
	$(document).on('click', '.pc_as_remove_cond', function() {
		if(confirm("<?php esc_attr_e('Remove condition?', PC_ML) ?>")) {
			$(this).parents('tr').fadeOut(300, function() {
				$(this).remove();
				
				if(!$('#pc_as_conds tr').length) {
					$('#pc_as_conds, #pc_as_submit').fadeOut(300); 
				}
			});
		}
	});
	
	
	/* advanced search - add condition */
	$(document).on('click', '.pc_as_add_cond', function() {
		const val     = $('.pc_as_fields').val(),
              f_name  = $('.pc_as_fields option[value="'+ val +'"]').html(),
              f_class = val.replace(/ /g, '_'),
              f_type  = ($('.pc_as_fields option[value="'+ val +'"]').data('is-date')) ? 'date' : 'text';
		
		if($('#pc_as_conds tr.'+f_class).length) {
			alert("<?php esc_attr_e('Field already used', PC_ML) ?>");
			return false;	
		}
		
        
        let opts;
        if(f_type == 'date') {
            opts = `
            <option value="like"><?php esc_attr_e('during', PC_ML) ?></option>
            <option value="bigger"><?php esc_attr_e('is sooner than', PC_ML) ?></option>	
            <option value="smaller"><?php esc_attr_e('is older than', PC_ML) ?></option>`;
        }
        else {
            opts = `
            <option value="equal"><?php esc_attr_e('is equal to', PC_ML) ?></option>
            <option value="different"><?php esc_attr_e('is different from', PC_ML) ?></option>	
            <option value="bigger"><?php esc_attr_e('is greater than', PC_ML) ?></option>	
            <option value="smaller"><?php esc_attr_e('is lower than', PC_ML) ?></option>
            <option value="like"><?php esc_attr_e('contains', PC_ML) ?></option>`;
        }
        
		const code = `
            <tr class="${ f_class }"><td>
                <span class="pc_as_remove_cond dashicons dashicons-no-alt" title="<?php esc_attr_e('remove condition', PC_ML) ?>"></span>
                <h4>${ f_name }</h4>
                <div>
                    <input type="hidden" name="pc_as_fields[]" value="${ val }" autocomplete="off" />
                    <select name="pc_as_cond[]">
                        ${ opts }
                    </select>
                    <input type="${ f_type }" name="pc_as_val[]" value="" autocomplete="off" />
                </div>
            </td>
        </tr>`;
		
		$('#pc_as_conds, #pc_as_submit').fadeIn(150); 
		$('#pc_as_conds').append(code);
	});
	
	
	/* show lightbox for advanced search */
	$(document).ready(function() {
        $('.pc_advanced_search_btn').magnificPopup({
              type: 'inline',
              preloader: false,
              callbacks: {
                beforeOpen: function() {
                  if($(window).width() < 800) {
                    this.st.focus = false;
                  }
                }
              }
        });
    });
		
	
	/* clean advanced search */
	$(document).on('click', '.pc_clean_advanced_search', function() {
		var url_arr = window.location.href.split('&');
		var new_url = [];
		
		$.each(url_arr, function(i, v) {
			if(typeof(v) != 'undefined') {
				if(v.indexOf('advanced_search=') === -1) {
					new_url.push(v);	
				}
			}
		});
		
		window.location.href = new_url.join('&'); 
	});

	
	/* sorting system */
	var order = '<?php echo (isset($_GET['order'])) ? esc_attr($_GET['order']) : 'desc'; ?>';
	var orderby = '<?php echo (isset($_GET['orderby'])) ? esc_attr($_GET['orderby']) : 'id'; ?>';
	
	$('.pc_filter_th[rel='+orderby+']').addClass('active_'+order);
	
	$(document).on('click', '.pc_filter_th', function() {
		var new_orderby = $(this).attr('rel');
		
		if(new_orderby == orderby) {
			var new_order = (order == 'asc') ? 'desc' : 'asc';	
		} else {
			var new_order = 'asc';	
		}

		var sort_url = window.location.href;
		
		if(sort_url.indexOf('orderby='+orderby) != -1) {
			sort_url = sort_url.replace('orderby='+orderby, 'orderby='+new_orderby).replace('order='+order, 'order='+new_order);
		} else {
			sort_url = sort_url + '&orderby='+ new_orderby +'&order='+ new_order;	
		}
		
		<?php if(isset($_GET['pagenum'])) : ?>
		sort_url = sort_url.replace('pagenum=<?php echo esc_attr($_GET['pagenum']) ?>', 'pagenum=1'); // back to page 1
		<?php endif; ?>
		
		window.location.href = sort_url;
	});
    
})(jQuery);    
</script>
